# this file has been automatically generated by valabind
import sys
from ctypes import *
from ctypes.util import find_library
if sys.platform.startswith('win'):
	lib = WinDLL (find_library ('r_asm'))
else:
	lib = CDLL (find_library ('r_asm'))
def rlist2array(x,y):
	it = x.iterator ()
	ret = []
	while True:
		data = it.get_data ()
		ds = cast (data, POINTER(y)).contents
		ret.append (ds)
		if it.n == None:
			break
		it = it.get_next ()
	return ret

class AddressHolder(object):
	def __get__(self, obj, type_):
		if getattr(obj, '_address', None) is None:
			obj._address = addressof(obj)
		return obj._address

	def __set__(self, obj, value):
		obj._address = value

class WrappedRMethod(object):
	def __init__(self, cname, args, ret):
		self.cname = cname
		self.args = args
		self.ret = ret
		self.args_set = False
		self.method = getattr(lib, cname)

	def __call__(self, *a):
		if not self.args_set:
			if self.args:
				self.method.argtypes = [eval(x.strip()) for x in self.args.split(',')]
			self.method.restype = eval(self.ret) if self.ret else None
			self.args_set = True
		return self.method(*a)

class WrappedApiMethod(object):
	def __init__(self, method, ret2, last):
		self.method = method
		self._o = None
		self.ret2 = ret2
		self.last = last

	def __call__(self, *a):
		result = self.method(self._o, *a)
		if self.ret2:
			result = eval(self.ret2)(result)
		if self.last:
			return getattr(result, self.last)
		return result

	def __get__(self, obj, type_):
		self._o = obj._o
		return self

def register(cname, args, ret):
	ret2 = last = None
	if ret:
		if ret[0]>='A' and ret[0]<='Z':
			x = ret.find('<')
			if x != -1:
				ret = ret[0:x]
			last = 'contents'
			ret = 'POINTER('+ret+')'
		else:
			last = 'value'
			ret2 = ret
			
	method = WrappedRMethod(cname, args, ret)
	wrapped_method = WrappedApiMethod(method, ret2, last)
	return wrapped_method, method

class RLibStruct(Structure): #0
	_fields_ = [
		("type", c_long),
		("data", c_void_p),
	]
class RAsm(Structure): #1
	_fields_ = [
		("bits", c_int),
		("big_endian", c_bool),
		("syntax", c_int),
		("pc", c_ulonglong),
		("plugins", c_void_p),
	]
	def __init__(self):
		Structure.__init__(self)
		r_asm_new = lib.r_asm_new
		r_asm_new.restype = c_void_p
		self._o = r_asm_new ()

	_o = AddressHolder()

	_get_plugins, r_asm_get_plugins = register('r_asm_get_plugins','c_void_p','RList<RAsmPlugin>')
	use, r_asm_use = register('r_asm_use','c_void_p, c_char_p','c_bool')
	set_arch, r_asm_set_arch = register('r_asm_set_arch','c_void_p, c_char_p, c_int','c_bool')
	set_bits, r_asm_set_bits = register('r_asm_set_bits','c_void_p, c_int','c_bool')
	set_syntax, r_asm_set_syntax = register('r_asm_set_syntax','c_void_p, c_long','c_bool')
	set_pc, r_asm_set_pc = register('r_asm_set_pc','c_void_p, c_ulonglong','c_bool')
	set_big_endian, r_asm_set_big_endian = register('r_asm_set_big_endian','c_void_p, c_bool','c_bool')
	disassemble, r_asm_disassemble = register('r_asm_disassemble','c_void_p, POINTER(RAsmOp), POINTER(c_ubyte), c_int','c_int')
	assemble, r_asm_assemble = register('r_asm_assemble','c_void_p, POINTER(RAsmOp), c_char_p','c_int')
	mdisassemble, r_asm_mdisassemble = register('r_asm_mdisassemble','c_void_p, POINTER(c_ubyte), c_int','RAsmCode')
	mdisassemble_hexstr, r_asm_mdisassemble_hexstr = register('r_asm_mdisassemble_hexstr','c_void_p, c_char_p','RAsmCode')
	massemble, r_asm_massemble = register('r_asm_massemble','c_void_p, c_char_p','RAsmCode')
	assemble_file, r_asm_assemble_file = register('r_asm_assemble_file','c_void_p, c_char_p','RAsmCode')
	to_string, r_asm_to_string = register('r_asm_to_string','c_void_p, c_ulonglong, POINTER(c_ubyte), c_int','c_char_p')
	from_string, r_asm_from_string = register('r_asm_from_string','c_void_p, c_ulonglong, c_char_p, POINTER(c_int)','POINTER(c_ubyte)')
	filter_input, r_asm_filter_input = register('r_asm_filter_input','c_void_p, c_char_p','c_bool')
	filter_output, r_asm_filter_output = register('r_asm_filter_output','c_void_p, c_char_p','c_bool')
	free, r_asm_free = register('r_asm_free','c_void_p',None)
	def get_plugins(self):
		return rlist2array(self._get_plugins(),RAsmPlugin)

class RAsmOp(Structure): #2
	_fields_ = [
		("size", c_int),
		("payload", c_int),
		('buf', c_ubyte * 128),
		('buf_asm', c_char * 128),
		('buf_hex', c_char * 128),
	]
	def __init__(self):
		Structure.__init__(self)

	_o = AddressHolder()

	get_hex, r_asm_op_get_hex = register('r_asm_op_get_hex','c_void_p','c_char_p')
	get_asm, r_asm_op_get_asm = register('r_asm_op_get_asm','c_void_p','c_char_p')

class RAsmCode(Structure): #3
	_fields_ = [
		("len", c_int),
		("buf", POINTER(c_ubyte)),
		("buf_hex", c_char_p),
		("buf_asm", c_char_p),
	]
class RAsmPlugin(Structure): #4
	_fields_ = [
		("name", c_char_p),
		("arch", c_char_p),
		("cpus", c_char_p),
		("desc", c_char_p),
		("license", c_char_p),
		("user", c_void_p),
		("bits", c_int),
	]
class RStrBuf(Structure): #5
	_fields_ = [
	]
	def __init__(self, str):
		Structure.__init__(self)
		r_strbuf_new = lib.r_strbuf_new
		r_strbuf_new.restype = c_void_p
		self._o = r_strbuf_new (str)

	_o = AddressHolder()

	set, r_strbuf_set = register('r_strbuf_set','c_void_p, c_char_p','c_bool')
	setf, r_strbuf_setf = register('r_strbuf_setf','c_void_p, c_char_p','c_bool')
	append, r_strbuf_append = register('r_strbuf_append','c_void_p, c_char_p','c_bool')
	get, r_strbuf_get = register('r_strbuf_get','c_void_p','c_char_p')

class RNum(Structure): #6
	_fields_ = [
	]
	def __init__(self, cb, cb2, user):
		Structure.__init__(self)
		r_num_new = lib.r_num_new
		r_num_new.restype = c_void_p
		self._o = r_num_new (cb, cb2, user)

	_o = AddressHolder()

	get, r_num_get = register('r_num_get','c_void_p, c_char_p','c_ulonglong')
	math, r_num_math = register('r_num_math','c_void_p, c_char_p','c_ulonglong')

class RBuffer(Structure): #7
	_fields_ = [
		("buf", POINTER(c_ubyte)),
		("length", c_int),
		("cur", c_int),
		("base", c_ulonglong),
	]
	def __init__(self):
		Structure.__init__(self)
		r_buf_new = lib.r_buf_new
		r_buf_new.restype = c_void_p
		self._o = r_buf_new ()

	_o = AddressHolder()

	read_at, r_buf_read_at = register('r_buf_read_at','c_void_p, c_ulonglong, POINTER(c_ubyte), c_int','c_int')
	write_at, r_buf_write_at = register('r_buf_write_at','c_void_p, c_ulonglong, POINTER(c_ubyte), c_int','c_int')
	set_bytes, r_buf_set_bytes = register('r_buf_set_bytes','c_void_p, POINTER(c_ubyte), c_int','c_bool')

class RList(Structure): #8
	_fields_ = [
	]
	def __init__(self):
		Structure.__init__(self)
		r_list_new = lib.r_list_new
		r_list_new.restype = c_void_p
		self._o = r_list_new ()
	def to_list(self,type):
		return rlist2array(self,type)

	_o = AddressHolder()

	append, r_list_append = register('r_list_append','c_void_p, c_void_p',None)
	prepend, r_list_prepend = register('r_list_prepend','c_void_p, c_void_p',None)
	iterator, r_list_iterator = register('r_list_iterator','c_void_p','RListIter')
	length, r_list_length = register('r_list_length','c_void_p','c_int')
	del_n, r_list_del_n = register('r_list_del_n','c_void_p, c_int','c_bool')
	get_top, r_list_get_top = register('r_list_get_top','c_void_p','c_bool')
	pop, r_list_pop = register('r_list_pop','c_void_p','c_void_p')

class RListIter(Structure): #9
	_fields_ = [
		("data", c_void_p),
		("n", c_void_p),
		("p", c_void_p),
	]
	def __init__(self):
		Structure.__init__(self)

	_o = AddressHolder()

	get_data, r_list_iter_get_data = register('r_list_iter_get_data','c_void_p','c_void_p')
	get_next, r_list_iter_get_next = register('r_list_iter_get_next','c_void_p','RListIter')

class RRange(Structure): #10
	_fields_ = [
	]
	def __init__(self):
		Structure.__init__(self)
		r_range_new = lib.r_range_new
		r_range_new.restype = c_void_p
		self._o = r_range_new ()
		r_range_new_from_string = lib.r_range_new_from_string
		r_range_new_from_string.restype = c_void_p
		self._o = r_range_new_from_string (str)

	_o = AddressHolder()

	item_get, r_range_item_get = register('r_range_item_get','c_void_p, c_ulonglong','POINTER(RRangeItem)')
	size, r_range_size = register('r_range_size','c_void_p','c_ulonglong')
	add_from_string, r_range_add_from_string = register('r_range_add_from_string','c_void_p, c_char_p','c_ulonglong')
	contains, r_range_contains = register('r_range_contains','c_void_p, c_ulonglong','c_bool')
	sort, r_range_sort = register('r_range_sort','c_void_p','c_bool')
	list, r_range_list = register('r_range_list','c_void_p, c_bool','c_bool')
	get_n, r_range_get_n = register('r_range_get_n','c_void_p, c_int, POINTER(c_ulonglong), POINTER(c_ulonglong)','c_bool')
	inverse, r_range_inverse = register('r_range_inverse','c_void_p, c_ulonglong, c_ulonglong, c_int','POINTER(RRange)')

class RRangeItem(Structure): #11
	_fields_ = [
		("fr", c_ulonglong),
		("to", c_ulonglong),
		("data", POINTER(c_ubyte)),
		("datalen", c_int),
	]
class RLib(Structure): #12
	_fields_ = [
	]
	def __init__(self, symname):
		Structure.__init__(self)
		r_lib_new = lib.r_lib_new
		r_lib_new.restype = c_void_p
		self._o = r_lib_new (symname)

	_o = AddressHolder()

	close, r_lib_close = register('r_lib_close','c_void_p, c_char_p','c_bool')
	opendir, r_lib_opendir = register('r_lib_opendir','c_void_p, c_char_p','c_int')
	path, r_lib_path = register('r_lib_path','c_char_p','c_char_p')
	dl_open, r_lib_dl_open = register('r_lib_dl_open','c_char_p','c_void_p')
	dl_sym, r_lib_dl_sym = register('r_lib_dl_sym','c_void_p, c_char_p','c_void_p')
	dl_close, r_lib_dl_close = register('r_lib_dl_close','c_void_p','c_bool')
	dl_check_filename, r_lib_dl_check_filename = register('r_lib_dl_check_filename','c_char_p','c_bool')
	del_handler, r_lib_del_handler = register('r_lib_del_handler','c_void_p, c_int','c_bool')

class RDiff(Structure): #13
	_fields_ = [
	]
	def __init__(self):
		Structure.__init__(self)
		r_diff_new = lib.r_diff_new
		r_diff_new.restype = c_void_p
		self._o = r_diff_new ()

	_o = AddressHolder()

	buffers, r_diff_buffers = register('r_diff_buffers','c_void_p, POINTER(c_ubyte), c_int, POINTER(c_ubyte), c_int','c_int')
	buffers_distance, r_diff_buffers_distance = register('r_diff_buffers_distance','c_void_p, POINTER(c_ubyte), c_int, POINTER(c_ubyte), c_int, POINTER(c_uint), POINTER(double)','c_int')
	set_delta, r_diff_set_delta = register('r_diff_set_delta','c_void_p, c_int','c_bool')

class RDiffOp(Structure): #14
	_fields_ = [
		("a_off", c_ulonglong),
		("a_buf", POINTER(c_ubyte)),
		("a_len", c_int),
		("b_off", c_ulonglong),
		("b_buf", POINTER(c_ubyte)),
		("b_len", c_int),
	]
